﻿using UnityEngine;
using System.Collections;

public class GaiaScript : MonoBehaviour {

	public GameObject LifePrefab;
	public GameObject RainLifePrefab;
	public Camera CameraReference;
	public bool Rain;
	public GameObject PlayerReference;
	public int gameSequence;
	public float startTime;
	public int livesTouched;
	public int memories;
	public GUIStyle guiSTYLEZ;
	public GUIStyle guiSTYLEZ_blue;
	public GUIStyle guiSTYLEZ_secret;
	public float twittertime;
	public bool soulmatefound;


	public Texture2D titlescreen;

	// 0 anims
	// 1 main titlescreen ready
	// 2 gameplay
	// 3 finale
	// 4 reset screen?

	// Use this for initialization
	void Start () {
		Rain = false;
		gameSequence = 0;
		memories = 0;
		livesTouched = 0;
		soulmatefound = false;

	}
	
	// Update is called once per frame
	void Update () {

		if (Input.GetKey (KeyCode.R))
			Rain = true;
		else
			Rain = false;

		if(Input.GetMouseButtonDown (0))
		{
			switch(gameSequence)
			{
			case 0:
				gameSequence = 1;
				//finishes anims
				break;
			case 1:
			  GameStart();
			  gameSequence = 2;
			  break;
			case 2:
				//player controlled at this point
				break;
			case 3:
				//autoplays finale
				break;
			case 4:
				Application.CaptureScreenshot("IWillBeRemembered.png");
				Application.Quit();
				break;
			default:
				break;
			}
		}

		//cheats
		if(Input.GetKeyDown(KeyCode.Alpha1))
		  gameSequence = 0;
		if(Input.GetKeyDown(KeyCode.Alpha2))
		  gameSequence = 1;
		if(Input.GetKeyDown(KeyCode.Alpha3))
		  gameSequence = 2;
		if(Input.GetKeyDown(KeyCode.Alpha4))
		  gameSequence = 3;


		if(gameSequence == 3)
		{
			if(Time.time - twittertime >= 16.0f)
				gameSequence = 4;
		}


	}

	void OnGUI ()
	{
		Color calph;
		switch(gameSequence)
		{
		case 0:
			calph = Color.white;
			calph.a = Time.time / 2.0f;

			GUI.color = calph;
			GUI.DrawTexture(new Rect(0,0, Screen.width, Screen.height), titlescreen, ScaleMode.ScaleToFit);

			if(Time.time > 2.0f)
				gameSequence = 1;
			break;

		case 1:
			calph = Color.white;
			calph.a = 1.0f;
			GUI.color = calph;
			GUI.DrawTexture(new Rect(0,0, Screen.width, Screen.height), titlescreen, ScaleMode.ScaleToFit); 
			break;
		case 2:
			calph = Color.white;
			calph.a = 1 - (Time.time - startTime / 1.0f);
			GUI.color = calph;			
			GUI.DrawTexture(new Rect(0,0, Screen.width, Screen.height), titlescreen, ScaleMode.ScaleToFit); 
			break;

		case 3:
			calph = Color.white;
			GUI.color = calph;
			GUI.Label(new Rect(Screen.width*0.65f, Screen.height *0.85f, Screen.width * 0.30f, Screen.height * 0.10f), "You touched " + livesTouched +" lives.\n" + (livesTouched + memories) +" people will remember you.", guiSTYLEZ);
			break;

		case 4:
			calph = Color.white;
			GUI.color = calph;
			GUI.Label(new Rect(Screen.width*0.65f, Screen.height *0.85f, Screen.width * 0.30f, Screen.height * 0.10f), "You touched " + livesTouched +" lives.\n" + (livesTouched + memories) +" people will remember you.", guiSTYLEZ);
			if(soulmatefound)
			{
				GUI.Label(new Rect(Screen.width*0.05f, Screen.height *0.05f, Screen.width * 0.30f, Screen.height * 0.10f), "You found your soul mate, who tells you about the R key.", guiSTYLEZ_secret);
			}
			GUI.Label(new Rect(Screen.width*0.05f, Screen.height *0.85f, Screen.width * 0.30f, Screen.height * 0.10f), "@npaavo #IWillBeRemembered", guiSTYLEZ_blue);
			break;


		}

	}

	public void GameStart()
	{
		PlayerScript pscriptref = (PlayerScript)PlayerReference.GetComponent("PlayerScript");
		pscriptref.GameStart ();
		GameObject gaia_GO_Reference;
		LifeScript gaia_LS_Reference;

		CamTrollyScript cts_ref;
		cts_ref = (CamTrollyScript)CameraReference.GetComponent ("CamTrollyScript");
		cts_ref.SetStartTime (Time.time);


		for (int i=0; i<1024; ++i) 
		{
			if(!Rain)
			{
				gaia_GO_Reference = (GameObject)Instantiate (LifePrefab, 
					         new Vector3((Random.value -0.5f) * 500.0f, 0.0f, (Random.value -0.5f) * 500.0f),
					         LifePrefab.transform.rotation);
				if(gaia_GO_Reference.transform.position.magnitude <= 5.0f)
				{
					//Debug.Log("Moving an object, nothing to see here...");
					gaia_GO_Reference.transform.position += new Vector3(10.0f, 0.0f, 10.0f);
				}
				gaia_LS_Reference = (LifeScript)gaia_GO_Reference.GetComponent("LifeScript");
				gaia_LS_Reference.SetStartTime(Time.time);
				gaia_LS_Reference.GaiaRef = this;
			}
			else
			{
				gaia_GO_Reference = (GameObject)Instantiate (RainLifePrefab, 
				             new Vector3((Random.value -0.5f) * 500.0f, 0.0f, (Random.value -0.5f) * 500.0f),
				             RainLifePrefab.transform.rotation);
				if(gaia_GO_Reference.transform.position.magnitude <= 5.0f)
				{
					//Debug.Log("Moving an object, nothing to see here...");
					gaia_GO_Reference.transform.position += new Vector3(10.0f, 0.0f, 10.0f);
				}
				gaia_LS_Reference = (LifeScript)gaia_GO_Reference.GetComponent("LifeScript");
				gaia_LS_Reference.SetStartTime(Time.time);
				gaia_LS_Reference.GaiaRef = this;
			}
		}

		if(!Rain)
		{
			gaia_GO_Reference = (GameObject)Instantiate (RainLifePrefab, 
			                                             new Vector3((Random.value -0.5f) * 500.0f, 0.0f, (Random.value -0.5f) * 500.0f),
			                                             LifePrefab.transform.rotation);
			gaia_LS_Reference = (LifeScript)gaia_GO_Reference.GetComponent("LifeScript");
			gaia_LS_Reference.SetStartTime(Time.time);
			gaia_LS_Reference.GaiaRef = this;
			gaia_LS_Reference.soulmate = true;
		}
		if(Rain)
		{
			gaia_GO_Reference = (GameObject)Instantiate (LifePrefab, 
			                                             new Vector3((Random.value -0.5f) * 500.0f, 0.0f, (Random.value -0.5f) * 500.0f),
			                                             LifePrefab.transform.rotation);
			gaia_LS_Reference = (LifeScript)gaia_GO_Reference.GetComponent("LifeScript");
			gaia_LS_Reference.SetStartTime(Time.time);
			gaia_LS_Reference.GaiaRef = this;
			gaia_LS_Reference.soulmate = true;
		}

		cts_ref.StartGame ();
		startTime = Time.time;

	}
}